//Don't use hax fag lol

//sounds
datablock AudioProfile(haxSound)
{
   filename    = "./haxFire.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(haxDrawSound)
{
   filename    = "./haxDraw.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(haxExplodeSound)
{
   filename    = "./monitorExplode.wav";
   description = AudioClose3d;
   preload = true;
};
//trail
datablock ParticleData(haxTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;

	textureName		= "./haxTrail.png";

	colors[0]	= "0.75 0.75 0.75 0.9";
	colors[1]	= "0.75 0.75 0.75 0.8";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 1.25;
	sizes[1]	= 1.45;
	sizes[2]	= 1.10;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(haxTrailEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  
   particles = haxTrailParticle;
   useEmitterColors = true;
   uiName = "hax Trail";
};
//smoke
datablock ParticleData(haxExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;

	textureName		= "base/data/particles/cloud";

	colors[0]	= "0.2 0.2 0.2 0.9";
	colors[1]	= "0.1 0.1 0.1 0.0";
	sizes[0]	= 3.0;
	sizes[1]	= 6.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(haxExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "haxExplosionParticle";

   useEmitterColors = true;
   uiName = "hax Explosion Smoke";
};
//stars
datablock ParticleData(haxExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.9 0.2 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 4.0;
	sizes[1]      = 3.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(haxExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "haxExplosionRingParticle";

   useEmitterColors = true;
   uiName = "hax Explosion Flash";
};
//debris trail
datablock ParticleData(haxDebrisTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;

	textureName		= "base/data/particles/cloud";

	colors[0]	= "0.0 0.0 0.0 0.250";
	colors[1]	= "0.0 0.0 0.0 0.350";
    colors[2]	= "0.0 0.0 0.0 0.0";

	sizes[0]	= 1.25;
	sizes[1]	= 1.45;
	sizes[2]	= 1.10;

	times[0]	= 0.0;
	times[1]	= 0.1;
    times[2]	= 1.0;
};
//debris trail
datablock ParticleEmitterData(haxDebrisTrailEmitter)
{
   ejectionPeriodMS = 90;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  
   overrideAdvance = false;
   particles = "haxDebrisTrailParticle";
   uiName = "hax Debris Trail";
};
//debris
datablock DebrisData(haxDebris)
{
	emitters  = haxDebrisTrailEmitter;
	
	shapeFile = "./monitor.dts";

	lifetime = 1.0;
	elasticity = 0.5;
	friction = 0;
	numBounces = 2;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	spinSpeed			= 200.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 400.0;

	gravModifier = 6;
};
//explosion
datablock ExplosionData(haxExplosion)
{
	soundProfile = haxExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = haxExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;
   
   debris = haxDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 45;
   debrisThetaMax = 115;
   debrisVelocity = 18;
   debrisVelocityVariance = 8;

   emitter[0] = haxExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   lightStartRadius = 3;
   lightEndRadius = 3;
   lightStartColor = "0.5 0.8 0.9";
   lightEndColor = "0 0 0";
   
   impulseRadius = 6;
   impulseForce = 2000;

   radiusDamage = 60;
   damageRadius = 3;
};
//projectile
AddDamageType("haxDirect",   '<bitmap:add-ons/Weapon_DrHax/CI_hax> %1',    '%2 <bitmap:add-ons/Weapon_DrHax/CI_hax> %1',1,1);
AddDamageType("haxRadius",   '<bitmap:add-ons/Weapon_DrHax/CI_haxRadius> %1',    '%2 <bitmap:add-ons/Weapon_DrHax/CI_haxRadius> %1',1,0);
datablock ProjectileData(haxProjectile)
{
   projectileShapeName = "./monitor.dts";
   directDamage        = 200;
   directDamageType  = $DamageType::haxDirect;
   radiusDamageType  = $DamageType::haxRadius;
   impactImpulse	   = 2000;
   verticalImpulse	   = 2000;
   explosion           = haxExplosion;
   particleEmitter     = haxTrailEmitter;

   brickExplosionRadius =1;
   brickExplosionImpact = true;
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 20;
   brickExplosionMaxVolumeFloating = 40;

   muzzleVelocity      = 90;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.50;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "HAX projectile";
};
//item
datablock ItemData(haxItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./monitor.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "HAX!";
	iconName = "./icon_hax";
	doColorShift = false;
	colorShiftColor = "0.68 0.71 0.76 1.000";

	image = haxImage;
	canDrop = true;
};
//image
datablock ShapeBaseImageData(haxImage)
{

   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = haxProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = "0.68 0.71 0.76 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.35;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= haxDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= haxSound;
	
    stateName[3]			  = "Reload";
	stateTimeoutValue[3]		  = 0.3;
	stateTransitionOnTimeout[3]	  = "Wait";
	stateWaitForTimeout[3]		  = true;
	stateEjectShell[3]       	  = true;
	
	stateName[4]			  = "Wait";
	stateTimeoutValue[4]		  = 0.5;
	stateTransitionOnTimeout[4]	  = "Ready";

};
//function
function haxImage::onFire(%this,%obj,%slot)
{
%obj.schedule(0, playThread, 2, "plant");
Parent::onFire(%this, %obj, %slot);
}